// Generated by CoffeeScript 1.4.0
(function() {
  var action, assert, async, fs, glob, mkdirs, path, _;

  path = require('path');

  fs = require('fs');

  glob = require('glob');

  assert = require('assert');

  async = require('async');

  _ = require('underscore');

  action = require('./core').action;

  mkdirs = require('./helpers').mkdirs;

  this.cat = function(inPaths, outPath, opts) {
    if (opts == null) {
      opts = {};
    }
    assert(typeof inPaths === 'string' || inPaths instanceof Array);
    assert(typeof outPath === 'string');
    inPaths = _(inPaths).chain().flatten().map(function(p) {
      return glob.sync(p);
    }).flatten().uniq().value();
    return action(inPaths, [outPath], function(_arg) {
      var callback, log;
      callback = _arg.callback, log = _arg.log;
      return async.parallel(inPaths.map(function(p) {
        return function(cb) {
          return fs.readFile(p, 'utf8', cb);
        };
      }), function(err, results) {
        var content, i, s;
        if (err) {
          throw err;
        }
        if (opts.transform) {
          results = (function() {
            var _i, _len, _results;
            _results = [];
            for (i = _i = 0, _len = results.length; _i < _len; i = ++_i) {
              content = results[i];
              _results.push(opts.transform(content, {
                path: inPaths[i]
              }));
            }
            return _results;
          })();
        }
        s = results.join('');
        return mkdirs(path.dirname(outPath), function() {
          log('writing ' + outPath);
          return fs.writeFile(outPath, s, function(err) {
            if (err) {
              throw err;
            }
            return callback();
          });
        });
      });
    });
  };

}).call(this);
