// Generated by CoffeeScript 1.4.0
(function() {
  var action, assert, basename, cs, dirname, fs, glob, join, mkdirs, _ref;

  _ref = require('path'), join = _ref.join, basename = _ref.basename, dirname = _ref.dirname;

  fs = require('fs');

  cs = require('coffee-script');

  glob = require('glob');

  assert = require('assert');

  action = require('./core').action;

  mkdirs = require('./helpers').mkdirs;

  this.coffee = function(sourceFiles, outputDir) {
    if (outputDir == null) {
      outputDir = '';
    }
    assert(typeof sourceFiles === 'string');
    assert(typeof outputDir === 'string');
    return glob.sync(sourceFiles).map(function(inPath) {
      var outPath;
      outPath = outputDir ? join(outputDir, basename(inPath).replace(/\.coffee$/, '.js')) : inPath.replace(/\.coffee$/, '.js');
      return action([inPath], [outPath], function(_arg) {
        var callback, log;
        callback = _arg.callback, log = _arg.log;
        log('reading ' + inPath);
        return fs.readFile(inPath, 'utf8', function(err, coffeeCode) {
          var jsCode;
          if (err) {
            throw err;
          }
          log('compiling');
          jsCode = cs.compile(coffeeCode, {
            filename: inPath
          });
          return mkdirs(dirname(outPath), function() {
            log('writing ' + outPath);
            return fs.writeFile(outPath, jsCode, function(err) {
              if (err) {
                throw err;
              }
              return callback();
            });
          });
        });
      });
    });
  };

}).call(this);
