// Generated by CoffeeScript 1.4.0
(function() {
  var action, assert, assertCalledOnce, fs, _,
    __slice = [].slice,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  fs = require('fs');

  assert = require('assert');

  _ = require('underscore');

  assertCalledOnce = require('./helpers').assertCalledOnce;

  this.action = action = function(inPaths, outPaths, perform) {
    assert(inPaths instanceof Array);
    assert(_.every(inPaths, function(x) {
      return typeof x === 'string';
    }));
    assert(outPaths instanceof Array);
    assert(_.every(outPaths, function(x) {
      return typeof x === 'string';
    }));
    assert(typeof perform === 'function');
    return {
      inPaths: inPaths,
      outPaths: outPaths,
      perform: perform
    };
  };

  this.build = function() {
    var a, actions, actionsBeingPerformed, callback, dirtyActions, done, earliestOut, f, fileInfos, getMTime, latestIn, oldActions, path, paths, queue, t0, x, y, _i, _j, _k, _l, _len, _len1, _len10, _len11, _len12, _len13, _len14, _len15, _len16, _len2, _len3, _len4, _len5, _len6, _len7, _len8, _len9, _m, _n, _o, _p, _q, _r, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _s, _t, _u, _v, _w, _x, _y;
    actions = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    t0 = Date.now();
    actions = _.flatten(actions);
    if (actions.length && typeof actions[actions.length - 1] === 'function') {
      callback = assertCalledOnce(actions.splice(-1)[0]);
    }
    for (_i = 0, _len = actions.length; _i < _len; _i++) {
      x = actions[_i];
      assert(typeof x === 'object');
      assert(x.inPaths instanceof Array);
      assert(_.every(x.inPaths, function(x) {
        return typeof x === 'string';
      }));
      assert(x.outPaths instanceof Array);
      assert(_.every(x.outPaths, function(x) {
        return typeof x === 'string';
      }));
      assert(typeof x.perform === 'function');
    }
    fileInfos = {};
    for (_j = 0, _len1 = actions.length; _j < _len1; _j++) {
      x = actions[_j];
      _ref = [x.inPaths, x.outPaths];
      for (_k = 0, _len2 = _ref.length; _k < _len2; _k++) {
        paths = _ref[_k];
        for (_l = 0, _len3 = paths.length; _l < _len3; _l++) {
          path = paths[_l];
          if ((_ref1 = fileInfos[path]) == null) {
            fileInfos[path] = {
              inActions: [],
              outActions: []
            };
          }
        }
      }
      _ref2 = x.inPaths;
      for (_m = 0, _len4 = _ref2.length; _m < _len4; _m++) {
        path = _ref2[_m];
        fileInfos[path].outActions.push(x);
      }
      _ref3 = x.outPaths;
      for (_n = 0, _len5 = _ref3.length; _n < _len5; _n++) {
        path = _ref3[_n];
        fileInfos[path].inActions.push(x);
      }
    }
    for (_o = 0, _len6 = actions.length; _o < _len6; _o++) {
      x = actions[_o];
      x.neighbours = _(x.outPaths).chain().map(function(path) {
        return fileInfos[path].outActions;
      }).flatten().uniq().value();
      assert(__indexOf.call(x.neighbours, x) < 0, 'Dependency graph contains a loop');
    }
    for (_p = 0, _len7 = actions.length; _p < _len7; _p++) {
      x = actions[_p];
      x.inDegree = 0;
    }
    for (_q = 0, _len8 = actions.length; _q < _len8; _q++) {
      x = actions[_q];
      _ref4 = x.neighbours;
      for (_r = 0, _len9 = _ref4.length; _r < _len9; _r++) {
        y = _ref4[_r];
        y.inDegree++;
      }
    }
    oldActions = actions;
    actions = [];
    done = false;
    while (!done) {
      done = true;
      for (_s = 0, _len10 = oldActions.length; _s < _len10; _s++) {
        x = oldActions[_s];
        if (!(__indexOf.call(actions, x) < 0 && x.inDegree === 0)) {
          continue;
        }
        done = false;
        actions.push(x);
        _ref5 = x.neighbours;
        for (_t = 0, _len11 = _ref5.length; _t < _len11; _t++) {
          y = _ref5[_t];
          y.inDegree--;
        }
      }
    }
    getMTime = _.memoize(function(path) {
      try {
        return fs.statSync(path).mtime.getTime();
      } catch (e) {
        return 0;
      }
    });
    for (_u = 0, _len12 = actions.length; _u < _len12; _u++) {
      a = actions[_u];
      if (!(!a.dirty)) {
        continue;
      }
      latestIn = Math.max.apply(Math, a.inPaths.map(getMTime));
      earliestOut = Math.min.apply(Math, a.outPaths.map(getMTime));
      if (earliestOut < latestIn) {
        a.dirty = true;
        queue = [a];
        while (queue.length) {
          x = queue.shift();
          _ref6 = x.outPaths;
          for (_v = 0, _len13 = _ref6.length; _v < _len13; _v++) {
            path = _ref6[_v];
            _ref7 = fileInfos[path].outActions;
            for (_w = 0, _len14 = _ref7.length; _w < _len14; _w++) {
              y = _ref7[_w];
              if (!y.dirty) {
                y.dirty = true;
                queue.push(y);
              }
            }
          }
        }
      }
    }
    dirtyActions = (function() {
      var _len15, _results, _x;
      _results = [];
      for (_x = 0, _len15 = actions.length; _x < _len15; _x++) {
        x = actions[_x];
        if (x.dirty) {
          _results.push(x);
        }
      }
      return _results;
    })();
    for (_x = 0, _len15 = dirtyActions.length; _x < _len15; _x++) {
      x = dirtyActions[_x];
      _ref8 = x.neighbours;
      for (_y = 0, _len16 = _ref8.length; _y < _len16; _y++) {
        y = _ref8[_y];
        y.inDegree++;
      }
    }
    actionsBeingPerformed = [];
    (f = function() {
      done = true;
      dirtyActions.forEach(function(x) {
        var log;
        if (!x.inDegree) {
          done = false;
          dirtyActions = _(dirtyActions).without(x);
          actionsBeingPerformed.push(x);
          log = function(message) {
            return console.info("" + (Date.now() - t0) + " [" + (x.outPaths.join(' ')) + "] " + message);
          };
          log('start');
          return x.perform({
            inPaths: x.inPaths,
            outPaths: x.outPaths,
            log: log,
            callback: assertCalledOnce(function() {
              var _len17, _ref9, _z;
              log('done');
              actionsBeingPerformed = _(actionsBeingPerformed).without(x);
              _ref9 = x.neighbours;
              for (_z = 0, _len17 = _ref9.length; _z < _len17; _z++) {
                y = _ref9[_z];
                y.inDegree--;
              }
              return typeof f === "function" ? f() : void 0;
            })
          });
        }
      });
      if (done && !actionsBeingPerformed.length) {
        f = null;
        return typeof callback === "function" ? callback() : void 0;
      }
    })();
  };

}).call(this);
