// Generated by CoffeeScript 1.4.0
(function() {
  var action, assert, basename, dirname, fs, glob, jade, join, mkdirs, _ref;

  _ref = require('path'), join = _ref.join, basename = _ref.basename, dirname = _ref.dirname;

  fs = require('fs');

  glob = require('glob');

  jade = require('jade');

  assert = require('assert');

  action = require('./core').action;

  mkdirs = require('./helpers').mkdirs;

  this.jade = function(sourceFiles, outputDir) {
    if (outputDir == null) {
      outputDir = '';
    }
    assert(typeof sourceFiles === 'string');
    assert(typeof outputDir === 'string');
    return glob.sync(sourceFiles).map(function(inPath) {
      var outPath;
      outPath = outputDir ? join(outputDir, basename(inPath).replace(/\.jade$/, '.html')) : inPath.replace(/\.jade$/, '.html');
      return action([inPath], [outPath], function(_arg) {
        var callback, log;
        callback = _arg.callback, log = _arg.log;
        log('reading ' + inPath);
        return fs.readFile(inPath, 'utf8', function(err, jadeCode) {
          var htmlCode;
          if (err) {
            throw err;
          }
          log('rendering jade template');
          htmlCode = jade.compile(jadeCode)();
          return mkdirs(dirname(outPath), function() {
            log('writing ' + outPath);
            return fs.writeFile(outPath, htmlCode, function(err) {
              if (err) {
                throw err;
              }
              return callback();
            });
          });
        });
      });
    });
  };

}).call(this);
