// Generated by CoffeeScript 1.4.0
(function() {
  var action, assert, basename, dirname, glob, join, spawn, _ref;

  _ref = require('path'), join = _ref.join, basename = _ref.basename, dirname = _ref.dirname;

  glob = require('glob');

  assert = require('assert');

  action = require('./core').action;

  spawn = require('child_process').spawn;

  this.sass = function(sourceFiles, outputDir) {
    if (outputDir == null) {
      outputDir = '';
    }
    assert(typeof sourceFiles === 'string');
    assert(typeof outputDir === 'string');
    return glob.sync(sourceFiles).map(function(inPath) {
      var outPath;
      outPath = outputDir ? join(outputDir, basename(inPath).replace(/\.sass$/, '.css')) : inPath.replace(/\.sass$/, '.css');
      return action([inPath], [outPath], function(_arg) {
        var callback, child, log;
        callback = _arg.callback, log = _arg.log;
        log('spawning sass ' + inPath);
        child = spawn('sass', ['--no-cache', inPath, outPath]);
        child.stdout.on('data', function(data) {
          return process.stdout.write(data);
        });
        child.stderr.on('data', function(data) {
          return process.stderr.write(data);
        });
        return child.on('exit', function(code) {
          if (code) {
            throw Error("Child process 'sass " + inPath + " " + outPath + "' returned exit code " + code + ".");
          }
          return callback();
        });
      });
    });
  };

}).call(this);
